package com.xxfc.platform.order.biz;

import com.github.wxiaoqi.security.admin.entity.AppUserLogin;
import com.github.wxiaoqi.security.admin.entity.BaseUserMemberLevel;
import com.github.wxiaoqi.security.admin.feign.UserFeign;
import com.github.wxiaoqi.security.common.biz.BaseBiz;
import com.github.wxiaoqi.security.common.exception.BaseException;
import com.github.wxiaoqi.security.common.util.process.ResultCode;
import com.xxfc.platform.order.entity.BaseOrder;
import com.xxfc.platform.order.entity.OrderMemberDetail;
import com.xxfc.platform.order.mapper.OrderMemberDetailMapper;
import com.xxfc.platform.order.pojo.order.add.AddMemberDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.concurrent.atomic.AtomicReference;

/**
 * 
 *
 * @author zjw
 * @email nishijjo@qq.com
 * @date 2019-06-19 17:00:35
 */
@Service
public class OrderMemberDetailBiz extends BaseBiz<OrderMemberDetailMapper,OrderMemberDetail> {

	@Autowired
	UserFeign userFeign;

	@Autowired
	BaseOrderBiz baseOrderBiz;

	/**
	 * 后台创建订单
	 * @param dto
	 */
	public void createOrder(AddMemberDTO dto) {
		AppUserLogin appUserLogin = userFeign.one(dto.getPhone());
		if (appUserLogin != null) {
			List<BaseUserMemberLevel> baseUserMemberLevelList = userFeign.levels();
			if (baseUserMemberLevelList != null && baseUserMemberLevelList.size() > 0) {
				BaseOrder baseOrder = new BaseOrder();
				AtomicReference<BaseUserMemberLevel> currentLevel = null;
				baseUserMemberLevelList.parallelStream().forEach(baseUserMemberLevel -> {
					if (dto.getMemberLevel().equals(baseUserMemberLevel.getLevel())) {
						currentLevel.set(baseUserMemberLevel);
					}
				});
				if (currentLevel != null && currentLevel.get() != null) {

				}

			} else {
				throw new BaseException(ResultCode.getMsg(ResultCode.USER_MEMBER_INFO_NOT_EXIST_CODE));
			}
		} else {
			throw new BaseException(ResultCode.getMsg(ResultCode.USER_NOTEXIST_CODE));
		}
	}

}